module.exports = grammar({
  name: 'fquest',

  rules: {

    source_file: $ => repeat(
        $._statement_with_optional_label
    ),

    tok_label: $ => /\n[A-Za-z][A-Za-z0-9_]*/,

    tok_identifier: $ => /[A-Za-z]([A-Za-z0-9_])*/,

    tok_comment: $ => /\ncomment[^\n]*\n/,

    tok_attributes_begin: $ => /\[\[/,

    tok_attributes_end: $ => /\]\]/,



    number: $ => /[+-]?[0-9]+/,


    _statement_with_optional_label: $ => seq(
        optional($.tok_label),
        $.statement
    ),

    statement: $ => choice(
         $.statement_attributes
//        ,$.statement_loopsa_special
//        ,$.statement_question
//        ,$.statement_define
//        ,'continue'
//        ,$.statement_fix
//        ,'protect'
//        ,$.statement_include
//        ,$.statement_if
//        ,$.statement_loop
//        ,$.statement_set
//        ,$.statement_display
//        ,$.statement_callfunc
//        ,$.statement_quota
//        ,$.statement_route
//        ,$.statement_stop
//        ,$.statement_start
//        ,$.statement_datamap
        ,'mapothzero'
        ,'othzero'
        ,'screener'
        ,'main'
        ,$.tok_comment
        ,'ranstart'
        ,'ranend'
        ,'newran'
        ,'rotstart'
        ,'rotend'
        ,'newrot'
        ,'gotosms'
        ,'pause'
        ,'unfreeze'
        ,'newpage'
        ,'newcard'
        ,seq('goto', $.tok_identifier)
//        ,seq('unset', $.expression)
        ,seq('column', $.number)
        ,seq('signal', $.number)
        ,seq('unprotect', $.tok_identifier)
//        ,seq('multiask', $.expression, $.statement_multiask)
//        ,seq('onresp', $.expression, 'go', $.tok_identifier)
        ,seq('end')
    ),

    statement_attributes: $ => seq(
        $.tok_attributes_begin,
        seq($.tok_identifier, optional(repeat(seq(',', $.tok_identifier)))),
        $.tok_attributes_end
    ),

  }
});
