#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 19
#define LARGE_STATE_COUNT 10
#define SYMBOL_COUNT 34
#define ALIAS_COUNT 0
#define TOKEN_COUNT 28
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 4
#define PRODUCTION_ID_COUNT 1

enum {
  sym_tok_label = 1,
  sym_tok_identifier = 2,
  sym_tok_comment = 3,
  sym_tok_attributes_begin = 4,
  sym_tok_attributes_end = 5,
  sym_number = 6,
  anon_sym_mapothzero = 7,
  anon_sym_othzero = 8,
  anon_sym_screener = 9,
  anon_sym_main = 10,
  anon_sym_ranstart = 11,
  anon_sym_ranend = 12,
  anon_sym_newran = 13,
  anon_sym_rotstart = 14,
  anon_sym_rotend = 15,
  anon_sym_newrot = 16,
  anon_sym_gotosms = 17,
  anon_sym_pause = 18,
  anon_sym_unfreeze = 19,
  anon_sym_newpage = 20,
  anon_sym_newcard = 21,
  anon_sym_goto = 22,
  anon_sym_column = 23,
  anon_sym_signal = 24,
  anon_sym_unprotect = 25,
  anon_sym_end = 26,
  anon_sym_COMMA = 27,
  sym_source_file = 28,
  sym__statement_with_optional_label = 29,
  sym_statement = 30,
  sym_statement_attributes = 31,
  aux_sym_source_file_repeat1 = 32,
  aux_sym_statement_attributes_repeat1 = 33,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_tok_label] = "tok_label",
  [sym_tok_identifier] = "tok_identifier",
  [sym_tok_comment] = "tok_comment",
  [sym_tok_attributes_begin] = "tok_attributes_begin",
  [sym_tok_attributes_end] = "tok_attributes_end",
  [sym_number] = "number",
  [anon_sym_mapothzero] = "mapothzero",
  [anon_sym_othzero] = "othzero",
  [anon_sym_screener] = "screener",
  [anon_sym_main] = "main",
  [anon_sym_ranstart] = "ranstart",
  [anon_sym_ranend] = "ranend",
  [anon_sym_newran] = "newran",
  [anon_sym_rotstart] = "rotstart",
  [anon_sym_rotend] = "rotend",
  [anon_sym_newrot] = "newrot",
  [anon_sym_gotosms] = "gotosms",
  [anon_sym_pause] = "pause",
  [anon_sym_unfreeze] = "unfreeze",
  [anon_sym_newpage] = "newpage",
  [anon_sym_newcard] = "newcard",
  [anon_sym_goto] = "goto",
  [anon_sym_column] = "column",
  [anon_sym_signal] = "signal",
  [anon_sym_unprotect] = "unprotect",
  [anon_sym_end] = "end",
  [anon_sym_COMMA] = ",",
  [sym_source_file] = "source_file",
  [sym__statement_with_optional_label] = "_statement_with_optional_label",
  [sym_statement] = "statement",
  [sym_statement_attributes] = "statement_attributes",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_statement_attributes_repeat1] = "statement_attributes_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_tok_label] = sym_tok_label,
  [sym_tok_identifier] = sym_tok_identifier,
  [sym_tok_comment] = sym_tok_comment,
  [sym_tok_attributes_begin] = sym_tok_attributes_begin,
  [sym_tok_attributes_end] = sym_tok_attributes_end,
  [sym_number] = sym_number,
  [anon_sym_mapothzero] = anon_sym_mapothzero,
  [anon_sym_othzero] = anon_sym_othzero,
  [anon_sym_screener] = anon_sym_screener,
  [anon_sym_main] = anon_sym_main,
  [anon_sym_ranstart] = anon_sym_ranstart,
  [anon_sym_ranend] = anon_sym_ranend,
  [anon_sym_newran] = anon_sym_newran,
  [anon_sym_rotstart] = anon_sym_rotstart,
  [anon_sym_rotend] = anon_sym_rotend,
  [anon_sym_newrot] = anon_sym_newrot,
  [anon_sym_gotosms] = anon_sym_gotosms,
  [anon_sym_pause] = anon_sym_pause,
  [anon_sym_unfreeze] = anon_sym_unfreeze,
  [anon_sym_newpage] = anon_sym_newpage,
  [anon_sym_newcard] = anon_sym_newcard,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_column] = anon_sym_column,
  [anon_sym_signal] = anon_sym_signal,
  [anon_sym_unprotect] = anon_sym_unprotect,
  [anon_sym_end] = anon_sym_end,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [sym_source_file] = sym_source_file,
  [sym__statement_with_optional_label] = sym__statement_with_optional_label,
  [sym_statement] = sym_statement,
  [sym_statement_attributes] = sym_statement_attributes,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_statement_attributes_repeat1] = aux_sym_statement_attributes_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_tok_label] = {
    .visible = true,
    .named = true,
  },
  [sym_tok_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_tok_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_tok_attributes_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_tok_attributes_end] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_mapothzero] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_othzero] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_screener] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_main] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ranstart] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ranend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newran] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rotstart] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rotend] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newrot] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_gotosms] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pause] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unfreeze] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newpage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_newcard] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_column] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_signal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unprotect] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statement_with_optional_label] = {
    .visible = false,
    .named = true,
  },
  [sym_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_attributes] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statement_attributes_repeat1] = {
    .visible = false,
    .named = false,
  },
};

static TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(101);
      if (lookahead == '\n') ADVANCE(2);
      if (lookahead == ',') ADVANCE(238);
      if (lookahead == '[') ADVANCE(6);
      if (lookahead == ']') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(62);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'g') ADVANCE(67);
      if (lookahead == 'm') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'p') ADVANCE(9);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(52);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(2);
      if (lookahead == ',') ADVANCE(238);
      if (lookahead == '[') ADVANCE(6);
      if (lookahead == ']') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(62);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'g') ADVANCE(67);
      if (lookahead == 'm') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'p') ADVANCE(9);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(52);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(2);
      if (lookahead == ',') ADVANCE(238);
      if (lookahead == '[') ADVANCE(6);
      if (lookahead == ']') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(156);
      if (lookahead == 'e') ADVANCE(145);
      if (lookahead == 'g') ADVANCE(160);
      if (lookahead == 'm') ADVANCE(103);
      if (lookahead == 'n') ADVANCE(119);
      if (lookahead == 'o') ADVANCE(174);
      if (lookahead == 'p') ADVANCE(104);
      if (lookahead == 'r') ADVANCE(107);
      if (lookahead == 's') ADVANCE(112);
      if (lookahead == 'u') ADVANCE(146);
      if (('+' <= lookahead && lookahead <= '-')) ADVANCE(100);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(194);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(5);
      if (lookahead == '[') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(62);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'g') ADVANCE(67);
      if (lookahead == 'm') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'p') ADVANCE(9);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(5);
      if (lookahead == '[') ADVANCE(6);
      if (lookahead == 'c') ADVANCE(66);
      if (lookahead == 'e') ADVANCE(51);
      if (lookahead == 'g') ADVANCE(67);
      if (lookahead == 'm') ADVANCE(8);
      if (lookahead == 'n') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'p') ADVANCE(9);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(17);
      if (lookahead == 'u') ADVANCE(52);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(4)
      END_STATE();
    case 6:
      if (lookahead == '[') ADVANCE(195);
      END_STATE();
    case 7:
      if (lookahead == ']') ADVANCE(196);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 9:
      if (lookahead == 'a') ADVANCE(93);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(45);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'o') ADVANCE(91);
      END_STATE();
    case 13:
      if (lookahead == 'a') ADVANCE(72);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 15:
      if (lookahead == 'a') ADVANCE(56);
      if (lookahead == 'o') ADVANCE(82);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 17:
      if (lookahead == 'c') ADVANCE(71);
      if (lookahead == 'i') ADVANCE(40);
      END_STATE();
    case 18:
      if (lookahead == 'c') ADVANCE(13);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(15);
      END_STATE();
    case 19:
      if (lookahead == 'c') ADVANCE(86);
      END_STATE();
    case 20:
      if (lookahead == 'd') ADVANCE(236);
      END_STATE();
    case 21:
      if (lookahead == 'd') ADVANCE(208);
      END_STATE();
    case 22:
      if (lookahead == 'd') ADVANCE(214);
      END_STATE();
    case 23:
      if (lookahead == 'd') ADVANCE(226);
      END_STATE();
    case 24:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 25:
      if (lookahead == 'e') ADVANCE(220);
      END_STATE();
    case 26:
      if (lookahead == 'e') ADVANCE(224);
      END_STATE();
    case 27:
      if (lookahead == 'e') ADVANCE(19);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 29:
      if (lookahead == 'e') ADVANCE(73);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 31:
      if (lookahead == 'e') ADVANCE(36);
      END_STATE();
    case 32:
      if (lookahead == 'e') ADVANCE(70);
      END_STATE();
    case 33:
      if (lookahead == 'e') ADVANCE(61);
      END_STATE();
    case 34:
      if (lookahead == 'e') ADVANCE(60);
      END_STATE();
    case 35:
      if (lookahead == 'e') ADVANCE(57);
      if (lookahead == 's') ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 37:
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 38:
      if (lookahead == 'e') ADVANCE(58);
      if (lookahead == 's') ADVANCE(90);
      END_STATE();
    case 39:
      if (lookahead == 'f') ADVANCE(78);
      if (lookahead == 'p') ADVANCE(77);
      END_STATE();
    case 40:
      if (lookahead == 'g') ADVANCE(59);
      END_STATE();
    case 41:
      if (lookahead == 'g') ADVANCE(26);
      END_STATE();
    case 42:
      if (lookahead == 'h') ADVANCE(96);
      END_STATE();
    case 43:
      if (lookahead == 'h') ADVANCE(98);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(54);
      if (lookahead == 'p') ADVANCE(69);
      END_STATE();
    case 45:
      if (lookahead == 'l') ADVANCE(232);
      END_STATE();
    case 46:
      if (lookahead == 'l') ADVANCE(94);
      END_STATE();
    case 47:
      if (lookahead == 'l') ADVANCE(94);
      if (lookahead == 'm') ADVANCE(50);
      END_STATE();
    case 48:
      if (lookahead == 'm') ADVANCE(79);
      END_STATE();
    case 49:
      if (lookahead == 'm') ADVANCE(55);
      END_STATE();
    case 50:
      if (lookahead == 'm') ADVANCE(34);
      END_STATE();
    case 51:
      if (lookahead == 'n') ADVANCE(20);
      END_STATE();
    case 52:
      if (lookahead == 'n') ADVANCE(39);
      END_STATE();
    case 53:
      if (lookahead == 'n') ADVANCE(35);
      END_STATE();
    case 54:
      if (lookahead == 'n') ADVANCE(204);
      END_STATE();
    case 55:
      if (lookahead == 'n') ADVANCE(230);
      END_STATE();
    case 56:
      if (lookahead == 'n') ADVANCE(210);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(21);
      END_STATE();
    case 58:
      if (lookahead == 'n') ADVANCE(22);
      END_STATE();
    case 59:
      if (lookahead == 'n') ADVANCE(10);
      END_STATE();
    case 60:
      if (lookahead == 'n') ADVANCE(85);
      END_STATE();
    case 61:
      if (lookahead == 'n') ADVANCE(32);
      END_STATE();
    case 62:
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 63:
      if (lookahead == 'o') ADVANCE(228);
      END_STATE();
    case 64:
      if (lookahead == 'o') ADVANCE(200);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(198);
      END_STATE();
    case 66:
      if (lookahead == 'o') ADVANCE(47);
      END_STATE();
    case 67:
      if (lookahead == 'o') ADVANCE(87);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(88);
      END_STATE();
    case 69:
      if (lookahead == 'o') ADVANCE(92);
      END_STATE();
    case 70:
      if (lookahead == 'r') ADVANCE(202);
      END_STATE();
    case 71:
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 72:
      if (lookahead == 'r') ADVANCE(23);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(64);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(65);
      END_STATE();
    case 75:
      if (lookahead == 'r') ADVANCE(83);
      END_STATE();
    case 76:
      if (lookahead == 'r') ADVANCE(84);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(68);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(31);
      END_STATE();
    case 79:
      if (lookahead == 's') ADVANCE(218);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(25);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(42);
      END_STATE();
    case 82:
      if (lookahead == 't') ADVANCE(216);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 84:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(3);
      END_STATE();
    case 86:
      if (lookahead == 't') ADVANCE(234);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(63);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(27);
      END_STATE();
    case 89:
      if (lookahead == 't') ADVANCE(14);
      END_STATE();
    case 90:
      if (lookahead == 't') ADVANCE(16);
      END_STATE();
    case 91:
      if (lookahead == 't') ADVANCE(38);
      END_STATE();
    case 92:
      if (lookahead == 't') ADVANCE(43);
      END_STATE();
    case 93:
      if (lookahead == 'u') ADVANCE(80);
      END_STATE();
    case 94:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 95:
      if (lookahead == 'w') ADVANCE(18);
      END_STATE();
    case 96:
      if (lookahead == 'z') ADVANCE(29);
      END_STATE();
    case 97:
      if (lookahead == 'z') ADVANCE(28);
      END_STATE();
    case 98:
      if (lookahead == 'z') ADVANCE(37);
      END_STATE();
    case 99:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(99)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(193);
      END_STATE();
    case 100:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == '\n') ADVANCE(194);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(102);
      if (lookahead != 0) ADVANCE(3);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(140);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(147);
      if (lookahead == 'o') ADVANCE(184);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(150);
      if (lookahead == 'o') ADVANCE(175);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'a') ADVANCE(169);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'c') ADVANCE(164);
      if (lookahead == 'i') ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'c') ADVANCE(108);
      if (lookahead == 'p') ADVANCE(106);
      if (lookahead == 'r') ADVANCE(110);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'c') ADVANCE(179);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'd') ADVANCE(237);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'd') ADVANCE(209);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'd') ADVANCE(215);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'd') ADVANCE(227);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(188);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(221);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(225);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(114);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(223);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(166);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(130);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(154);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(155);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(151);
      if (lookahead == 's') ADVANCE(182);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(190);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(128);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(167);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'e') ADVANCE(152);
      if (lookahead == 's') ADVANCE(183);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'f') ADVANCE(171);
      if (lookahead == 'p') ADVANCE(170);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'g') ADVANCE(153);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'g') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'h') ADVANCE(189);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'h') ADVANCE(191);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'p') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'l') ADVANCE(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'l') ADVANCE(187);
      if (lookahead == 'm') ADVANCE(143);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'm') ADVANCE(172);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'm') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'm') ADVANCE(149);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(134);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(205);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(211);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(116);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(176);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'n') ADVANCE(126);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'o') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'o') ADVANCE(229);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'o') ADVANCE(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'o') ADVANCE(199);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'o') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'o') ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'o') ADVANCE(185);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(203);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(118);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(178);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'r') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 's') ADVANCE(219);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 's') ADVANCE(120);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(137);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(217);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(102);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(207);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(213);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(157);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(122);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 't') ADVANCE(138);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'u') ADVANCE(173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'u') ADVANCE(144);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'w') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'z') ADVANCE(124);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(192);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'z') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(192);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_tok_label);
      if (lookahead == 'z') ADVANCE(132);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'y')) ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_tok_label);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(sym_tok_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(193);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(sym_tok_comment);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(sym_tok_attributes_begin);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_tok_attributes_end);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_mapothzero);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_mapothzero);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_othzero);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_othzero);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_screener);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_screener);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_main);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_main);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_ranstart);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_ranstart);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_ranend);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_ranend);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_newran);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_newran);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_rotstart);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_rotstart);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_rotend);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(anon_sym_rotend);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_newrot);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_newrot);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_gotosms);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_gotosms);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_pause);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_pause);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_unfreeze);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_unfreeze);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_newpage);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_newpage);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_newcard);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_newcard);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_goto);
      if (lookahead == 's') ADVANCE(48);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_goto);
      if (lookahead == 's') ADVANCE(142);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_column);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_column);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_signal);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_signal);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_unprotect);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_unprotect);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_end);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(192);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 0},
  [3] = {.lex_state = 0},
  [4] = {.lex_state = 4},
  [5] = {.lex_state = 0},
  [6] = {.lex_state = 0},
  [7] = {.lex_state = 0},
  [8] = {.lex_state = 0},
  [9] = {.lex_state = 0},
  [10] = {.lex_state = 0},
  [11] = {.lex_state = 0},
  [12] = {.lex_state = 0},
  [13] = {.lex_state = 0},
  [14] = {.lex_state = 99},
  [15] = {.lex_state = 99},
  [16] = {.lex_state = 0},
  [17] = {.lex_state = 0},
  [18] = {.lex_state = 99},
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_tok_label] = ACTIONS(1),
    [sym_tok_comment] = ACTIONS(1),
    [sym_tok_attributes_begin] = ACTIONS(1),
    [sym_tok_attributes_end] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_mapothzero] = ACTIONS(1),
    [anon_sym_othzero] = ACTIONS(1),
    [anon_sym_screener] = ACTIONS(1),
    [anon_sym_main] = ACTIONS(1),
    [anon_sym_ranstart] = ACTIONS(1),
    [anon_sym_ranend] = ACTIONS(1),
    [anon_sym_newran] = ACTIONS(1),
    [anon_sym_rotstart] = ACTIONS(1),
    [anon_sym_rotend] = ACTIONS(1),
    [anon_sym_newrot] = ACTIONS(1),
    [anon_sym_gotosms] = ACTIONS(1),
    [anon_sym_pause] = ACTIONS(1),
    [anon_sym_unfreeze] = ACTIONS(1),
    [anon_sym_newpage] = ACTIONS(1),
    [anon_sym_newcard] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_column] = ACTIONS(1),
    [anon_sym_signal] = ACTIONS(1),
    [anon_sym_unprotect] = ACTIONS(1),
    [anon_sym_end] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
  },
  [1] = {
    [sym_source_file] = STATE(17),
    [sym__statement_with_optional_label] = STATE(2),
    [sym_statement] = STATE(2),
    [sym_statement_attributes] = STATE(5),
    [aux_sym_source_file_repeat1] = STATE(2),
    [ts_builtin_sym_end] = ACTIONS(3),
    [sym_tok_label] = ACTIONS(5),
    [sym_tok_comment] = ACTIONS(7),
    [sym_tok_attributes_begin] = ACTIONS(9),
    [anon_sym_mapothzero] = ACTIONS(11),
    [anon_sym_othzero] = ACTIONS(11),
    [anon_sym_screener] = ACTIONS(11),
    [anon_sym_main] = ACTIONS(11),
    [anon_sym_ranstart] = ACTIONS(11),
    [anon_sym_ranend] = ACTIONS(11),
    [anon_sym_newran] = ACTIONS(11),
    [anon_sym_rotstart] = ACTIONS(11),
    [anon_sym_rotend] = ACTIONS(11),
    [anon_sym_newrot] = ACTIONS(11),
    [anon_sym_gotosms] = ACTIONS(11),
    [anon_sym_pause] = ACTIONS(11),
    [anon_sym_unfreeze] = ACTIONS(11),
    [anon_sym_newpage] = ACTIONS(11),
    [anon_sym_newcard] = ACTIONS(11),
    [anon_sym_goto] = ACTIONS(13),
    [anon_sym_column] = ACTIONS(15),
    [anon_sym_signal] = ACTIONS(15),
    [anon_sym_unprotect] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(11),
  },
  [2] = {
    [sym__statement_with_optional_label] = STATE(3),
    [sym_statement] = STATE(3),
    [sym_statement_attributes] = STATE(5),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(17),
    [sym_tok_label] = ACTIONS(5),
    [sym_tok_comment] = ACTIONS(7),
    [sym_tok_attributes_begin] = ACTIONS(9),
    [anon_sym_mapothzero] = ACTIONS(11),
    [anon_sym_othzero] = ACTIONS(11),
    [anon_sym_screener] = ACTIONS(11),
    [anon_sym_main] = ACTIONS(11),
    [anon_sym_ranstart] = ACTIONS(11),
    [anon_sym_ranend] = ACTIONS(11),
    [anon_sym_newran] = ACTIONS(11),
    [anon_sym_rotstart] = ACTIONS(11),
    [anon_sym_rotend] = ACTIONS(11),
    [anon_sym_newrot] = ACTIONS(11),
    [anon_sym_gotosms] = ACTIONS(11),
    [anon_sym_pause] = ACTIONS(11),
    [anon_sym_unfreeze] = ACTIONS(11),
    [anon_sym_newpage] = ACTIONS(11),
    [anon_sym_newcard] = ACTIONS(11),
    [anon_sym_goto] = ACTIONS(13),
    [anon_sym_column] = ACTIONS(15),
    [anon_sym_signal] = ACTIONS(15),
    [anon_sym_unprotect] = ACTIONS(13),
    [anon_sym_end] = ACTIONS(11),
  },
  [3] = {
    [sym__statement_with_optional_label] = STATE(3),
    [sym_statement] = STATE(3),
    [sym_statement_attributes] = STATE(5),
    [aux_sym_source_file_repeat1] = STATE(3),
    [ts_builtin_sym_end] = ACTIONS(19),
    [sym_tok_label] = ACTIONS(21),
    [sym_tok_comment] = ACTIONS(24),
    [sym_tok_attributes_begin] = ACTIONS(27),
    [anon_sym_mapothzero] = ACTIONS(30),
    [anon_sym_othzero] = ACTIONS(30),
    [anon_sym_screener] = ACTIONS(30),
    [anon_sym_main] = ACTIONS(30),
    [anon_sym_ranstart] = ACTIONS(30),
    [anon_sym_ranend] = ACTIONS(30),
    [anon_sym_newran] = ACTIONS(30),
    [anon_sym_rotstart] = ACTIONS(30),
    [anon_sym_rotend] = ACTIONS(30),
    [anon_sym_newrot] = ACTIONS(30),
    [anon_sym_gotosms] = ACTIONS(30),
    [anon_sym_pause] = ACTIONS(30),
    [anon_sym_unfreeze] = ACTIONS(30),
    [anon_sym_newpage] = ACTIONS(30),
    [anon_sym_newcard] = ACTIONS(30),
    [anon_sym_goto] = ACTIONS(33),
    [anon_sym_column] = ACTIONS(36),
    [anon_sym_signal] = ACTIONS(36),
    [anon_sym_unprotect] = ACTIONS(33),
    [anon_sym_end] = ACTIONS(30),
  },
  [4] = {
    [sym_statement] = STATE(6),
    [sym_statement_attributes] = STATE(5),
    [sym_tok_comment] = ACTIONS(7),
    [sym_tok_attributes_begin] = ACTIONS(9),
    [anon_sym_mapothzero] = ACTIONS(7),
    [anon_sym_othzero] = ACTIONS(7),
    [anon_sym_screener] = ACTIONS(7),
    [anon_sym_main] = ACTIONS(7),
    [anon_sym_ranstart] = ACTIONS(7),
    [anon_sym_ranend] = ACTIONS(7),
    [anon_sym_newran] = ACTIONS(7),
    [anon_sym_rotstart] = ACTIONS(7),
    [anon_sym_rotend] = ACTIONS(7),
    [anon_sym_newrot] = ACTIONS(7),
    [anon_sym_gotosms] = ACTIONS(7),
    [anon_sym_pause] = ACTIONS(7),
    [anon_sym_unfreeze] = ACTIONS(7),
    [anon_sym_newpage] = ACTIONS(7),
    [anon_sym_newcard] = ACTIONS(7),
    [anon_sym_goto] = ACTIONS(13),
    [anon_sym_column] = ACTIONS(39),
    [anon_sym_signal] = ACTIONS(39),
    [anon_sym_unprotect] = ACTIONS(41),
    [anon_sym_end] = ACTIONS(7),
  },
  [5] = {
    [ts_builtin_sym_end] = ACTIONS(43),
    [sym_tok_label] = ACTIONS(45),
    [sym_tok_comment] = ACTIONS(43),
    [sym_tok_attributes_begin] = ACTIONS(43),
    [anon_sym_mapothzero] = ACTIONS(45),
    [anon_sym_othzero] = ACTIONS(45),
    [anon_sym_screener] = ACTIONS(45),
    [anon_sym_main] = ACTIONS(45),
    [anon_sym_ranstart] = ACTIONS(45),
    [anon_sym_ranend] = ACTIONS(45),
    [anon_sym_newran] = ACTIONS(45),
    [anon_sym_rotstart] = ACTIONS(45),
    [anon_sym_rotend] = ACTIONS(45),
    [anon_sym_newrot] = ACTIONS(45),
    [anon_sym_gotosms] = ACTIONS(45),
    [anon_sym_pause] = ACTIONS(45),
    [anon_sym_unfreeze] = ACTIONS(45),
    [anon_sym_newpage] = ACTIONS(45),
    [anon_sym_newcard] = ACTIONS(45),
    [anon_sym_goto] = ACTIONS(45),
    [anon_sym_column] = ACTIONS(45),
    [anon_sym_signal] = ACTIONS(45),
    [anon_sym_unprotect] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(45),
  },
  [6] = {
    [ts_builtin_sym_end] = ACTIONS(47),
    [sym_tok_label] = ACTIONS(49),
    [sym_tok_comment] = ACTIONS(47),
    [sym_tok_attributes_begin] = ACTIONS(47),
    [anon_sym_mapothzero] = ACTIONS(49),
    [anon_sym_othzero] = ACTIONS(49),
    [anon_sym_screener] = ACTIONS(49),
    [anon_sym_main] = ACTIONS(49),
    [anon_sym_ranstart] = ACTIONS(49),
    [anon_sym_ranend] = ACTIONS(49),
    [anon_sym_newran] = ACTIONS(49),
    [anon_sym_rotstart] = ACTIONS(49),
    [anon_sym_rotend] = ACTIONS(49),
    [anon_sym_newrot] = ACTIONS(49),
    [anon_sym_gotosms] = ACTIONS(49),
    [anon_sym_pause] = ACTIONS(49),
    [anon_sym_unfreeze] = ACTIONS(49),
    [anon_sym_newpage] = ACTIONS(49),
    [anon_sym_newcard] = ACTIONS(49),
    [anon_sym_goto] = ACTIONS(49),
    [anon_sym_column] = ACTIONS(49),
    [anon_sym_signal] = ACTIONS(49),
    [anon_sym_unprotect] = ACTIONS(49),
    [anon_sym_end] = ACTIONS(49),
  },
  [7] = {
    [ts_builtin_sym_end] = ACTIONS(51),
    [sym_tok_label] = ACTIONS(53),
    [sym_tok_comment] = ACTIONS(51),
    [sym_tok_attributes_begin] = ACTIONS(51),
    [anon_sym_mapothzero] = ACTIONS(53),
    [anon_sym_othzero] = ACTIONS(53),
    [anon_sym_screener] = ACTIONS(53),
    [anon_sym_main] = ACTIONS(53),
    [anon_sym_ranstart] = ACTIONS(53),
    [anon_sym_ranend] = ACTIONS(53),
    [anon_sym_newran] = ACTIONS(53),
    [anon_sym_rotstart] = ACTIONS(53),
    [anon_sym_rotend] = ACTIONS(53),
    [anon_sym_newrot] = ACTIONS(53),
    [anon_sym_gotosms] = ACTIONS(53),
    [anon_sym_pause] = ACTIONS(53),
    [anon_sym_unfreeze] = ACTIONS(53),
    [anon_sym_newpage] = ACTIONS(53),
    [anon_sym_newcard] = ACTIONS(53),
    [anon_sym_goto] = ACTIONS(53),
    [anon_sym_column] = ACTIONS(53),
    [anon_sym_signal] = ACTIONS(53),
    [anon_sym_unprotect] = ACTIONS(53),
    [anon_sym_end] = ACTIONS(53),
  },
  [8] = {
    [ts_builtin_sym_end] = ACTIONS(55),
    [sym_tok_label] = ACTIONS(57),
    [sym_tok_comment] = ACTIONS(55),
    [sym_tok_attributes_begin] = ACTIONS(55),
    [anon_sym_mapothzero] = ACTIONS(57),
    [anon_sym_othzero] = ACTIONS(57),
    [anon_sym_screener] = ACTIONS(57),
    [anon_sym_main] = ACTIONS(57),
    [anon_sym_ranstart] = ACTIONS(57),
    [anon_sym_ranend] = ACTIONS(57),
    [anon_sym_newran] = ACTIONS(57),
    [anon_sym_rotstart] = ACTIONS(57),
    [anon_sym_rotend] = ACTIONS(57),
    [anon_sym_newrot] = ACTIONS(57),
    [anon_sym_gotosms] = ACTIONS(57),
    [anon_sym_pause] = ACTIONS(57),
    [anon_sym_unfreeze] = ACTIONS(57),
    [anon_sym_newpage] = ACTIONS(57),
    [anon_sym_newcard] = ACTIONS(57),
    [anon_sym_goto] = ACTIONS(57),
    [anon_sym_column] = ACTIONS(57),
    [anon_sym_signal] = ACTIONS(57),
    [anon_sym_unprotect] = ACTIONS(57),
    [anon_sym_end] = ACTIONS(57),
  },
  [9] = {
    [ts_builtin_sym_end] = ACTIONS(59),
    [sym_tok_label] = ACTIONS(61),
    [sym_tok_comment] = ACTIONS(59),
    [sym_tok_attributes_begin] = ACTIONS(59),
    [anon_sym_mapothzero] = ACTIONS(61),
    [anon_sym_othzero] = ACTIONS(61),
    [anon_sym_screener] = ACTIONS(61),
    [anon_sym_main] = ACTIONS(61),
    [anon_sym_ranstart] = ACTIONS(61),
    [anon_sym_ranend] = ACTIONS(61),
    [anon_sym_newran] = ACTIONS(61),
    [anon_sym_rotstart] = ACTIONS(61),
    [anon_sym_rotend] = ACTIONS(61),
    [anon_sym_newrot] = ACTIONS(61),
    [anon_sym_gotosms] = ACTIONS(61),
    [anon_sym_pause] = ACTIONS(61),
    [anon_sym_unfreeze] = ACTIONS(61),
    [anon_sym_newpage] = ACTIONS(61),
    [anon_sym_newcard] = ACTIONS(61),
    [anon_sym_goto] = ACTIONS(61),
    [anon_sym_column] = ACTIONS(61),
    [anon_sym_signal] = ACTIONS(61),
    [anon_sym_unprotect] = ACTIONS(61),
    [anon_sym_end] = ACTIONS(61),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 3,
    ACTIONS(63), 1,
      sym_tok_attributes_end,
    ACTIONS(65), 1,
      anon_sym_COMMA,
    STATE(11), 1,
      aux_sym_statement_attributes_repeat1,
  [10] = 3,
    ACTIONS(65), 1,
      anon_sym_COMMA,
    ACTIONS(67), 1,
      sym_tok_attributes_end,
    STATE(12), 1,
      aux_sym_statement_attributes_repeat1,
  [20] = 3,
    ACTIONS(69), 1,
      sym_tok_attributes_end,
    ACTIONS(71), 1,
      anon_sym_COMMA,
    STATE(12), 1,
      aux_sym_statement_attributes_repeat1,
  [30] = 1,
    ACTIONS(69), 2,
      sym_tok_attributes_end,
      anon_sym_COMMA,
  [35] = 1,
    ACTIONS(74), 1,
      sym_tok_identifier,
  [39] = 1,
    ACTIONS(76), 1,
      sym_tok_identifier,
  [43] = 1,
    ACTIONS(76), 1,
      sym_number,
  [47] = 1,
    ACTIONS(78), 1,
      ts_builtin_sym_end,
  [51] = 1,
    ACTIONS(80), 1,
      sym_tok_identifier,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(10)] = 0,
  [SMALL_STATE(11)] = 10,
  [SMALL_STATE(12)] = 20,
  [SMALL_STATE(13)] = 30,
  [SMALL_STATE(14)] = 35,
  [SMALL_STATE(15)] = 39,
  [SMALL_STATE(16)] = 43,
  [SMALL_STATE(17)] = 47,
  [SMALL_STATE(18)] = 51,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [17] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [19] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [21] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4),
  [24] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5),
  [27] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(14),
  [30] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(5),
  [33] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(15),
  [36] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(16),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [43] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 1),
  [45] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 1),
  [47] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement_with_optional_label, 2),
  [49] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement_with_optional_label, 2),
  [51] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement, 2),
  [53] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement, 2),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_attributes, 3),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_attributes, 3),
  [59] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_attributes, 4),
  [61] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_attributes, 4),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [69] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statement_attributes_repeat1, 2),
  [71] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statement_attributes_repeat1, 2), SHIFT_REPEAT(18),
  [74] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [76] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [78] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [80] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_fquest(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = (const uint16_t *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
